{
 Ручное управление роботом с клавиатуры (mot3_1.pp)

 Требования:
 Два больших мотора, левый подключен к
 порту с меньшим номером, правый - к порту
 с большим номером.

 Запуск - в ssh-сессии, рекомендуется беспроводное 
 подключение к роботу.
 При старте программы выводится справка по 
 клавишам управления.
}

{$mode objfpc}
uses crt,uev3,rubiroMotors;

function run(ch:char; speed:integer):char;
begin
 result:=ch;
 case ch of
   #72:ev3rule.Run(0,speed);
   #80:ev3rule.Run(0,-speed);
   #75:ev3rule.Run(-100,speed);
   #77:ev3rule.Run(100,speed)
   else begin 
    ev3rule.Stop(); exit(#0); 
   end;
 end;
end;

var ch,command:char;
    speed:integer=20;

begin
 writeln('Роботом с ручным управлением');
 writeln('Клавиша ESC - завершение программы');
 writeln('Клавиши курсора ↑,←,→,↓ - движение робота');
 writeln('Клавиши от 1 до 9 - скорость робота');
 writeln('Остальные клавиши - остановка робота');
 ev3init();
 command:=#0;
 while true do begin
   ch:=readkey;
   if ch=#27 then exit;
   if ch in ['1'..'9'] then begin
    speed:=10*(ord(ch)-ord('0'));
    run(command,speed);
   end
   else if ch=#0 then command:=run(readkey,speed)
   else ev3Rule.Stop();
 end;
end.
