{
 Демонстрация датчика гироскопа (sns4_1.pp)
 При старте программы робот должен находиться в состоянии покоя.
 Калибровкой датчика гироскопа фиксируется первоначальное
 направление робота.
 Если направление робота изменяется (например - ручным перемещением
 в другое положение), то выждав 5-секундний 
 интервал, робот плавно возвращается в исходное положение
 с помощью вращения вокруг своей оси. 

 Требования:
 Два больших мотора, левый подключен к
 порту с меньшим номером, правый - к порту
 с большим номером.
 Датчик гироскопа, подключен к любому порту.

}
{$mode objfpc}
uses uev3,rubiroSensors,rubiroMotors,math;
 var angle:integer;
begin
  ev3Init();
  ev3Gyro.calibrate;
  ev3Rule.timerStart;
  while true do begin
    angle:=ev3Gyro.angle;
    if (angle>-10)and(angle<10) then 
     ev3Rule.Stop().timerStart
    else begin
     if ev3Rule.timer<5000 then continue;
     ev3Rule.Run(-100*sign(angle),10+sqrt(abs(angle)));
    end;
  end;
end.

